; $Id: choice.scm,v 1.5 2006/10/02 17:09:33 me Exp $ -*- scheme -*-

(document:surround "/std/frame")
(document:insert "/std/functions")
(document:insert "/evms/functions")

(document:envelop with-translation _ "alterator-vm")
(document:envelop with-init-attributes (orientation))

width 480
height 320
margin 5
spacing 5
children-align center

;---------------------------------------------------------------
(define (rl-rows)
  (map (lambda (path)
         (_ (woo-get-option
             (woo-first-command
              (woo-read path)) 'title)))
       (global 'task-paths)))

(define (rl-selected)
  (for-each
   (lambda (task-path) (woo 'destroy task-path))
   (list-remove (global 'task-paths) (rl current)))
  `((task ,(global 'action) ,(global 'next-action) ,(list-ref (global 'task-paths) (rl current)))))

(and (global 'title)
     (string? (global 'title))
     (label (string-append "<center><b>"(global 'title) "</b><center>")))

(groupbox
 (_ "Select")
 (layout-policy 100 -1)
 (document:id rl (radiolist rows '()
                            layout-policy 100 -1
                            (when selected (rl current (rl active))))))

(groupbox
 ""
 orientation 'horizontal
 (button (_ "OK") (when clicked (document:end (rl-selected))))
 (button (_ "Cancel") focus #t (when clicked (document:end '((cancel))))))

(when loaded
  (rl rows (rl-rows))
  (rl current 0))
